# -*- cperl -*-

package Dialog_Czech;
#binding-context Dialog_Czech
#key-binding-adopt TredMacro

BEGIN { import TMT; }

sub allow_switch_context_hook {
  return 'stop' if not TMT::is_tmt_file();
}

sub switch_context_hook {
  SetCurrentStylesheet('Dialog_Czech');
  Redraw() if GUI();
}

sub get_value_line_hook {
  my ($fsfile,$treeNo)=@_;
  return unless $fsfile;
  my $bundle = $fsfile->tree($treeNo);
  return unless $bundle;

  
  if (defined $bundle->{generic_subbundles}) {
  	my @subs = $bundle->{generic_subbundles}->elements;
  	my $subbundle = TMT::get_generic_subbundle($bundle, 'cs', 'S');
  	return $subbundle->{'speaker.rf'} . " " . "(" . $subbundle->{'sentence_type'} . ")" . " " . $subbundle->{'sentence'}."\n";
  } else {
  	my $speaker = $bundle->attr("dialog/from");
  	return my $speaker = $speaker . ": " . $bundle->{czech_source_sentence} . "\n" . $bundle->{czech_target_sentence};
  }
}

sub get_nodelist_hook {
  my ($fsfile, $treeNo, $currentNode, $hidden)=@_;
  my $bundle = $fsfile->tree($treeNo);
  my $ord = FS()->order;

  my @nodes = get_all_nodes_to_display($bundle);

  #print "Ord uzlu:\n";
  #print join " ",map{"o=$_->{ord}"} @nodes;
  #print "\n";
  $currentNode=$nodes[0] unless first { $_==$currentNode } @nodes;
  return [\@nodes, $currentNode];
}

sub get_all_nodes_to_display {
  my $bundle = shift;
  my ($sm_trees,
      $sn_trees,
      $sp_trees,
      $sa_trees,
      $st_trees,
      $tt_trees,
      $ta_trees) = TMT::group_nodes_by_direction_and_layer($bundle);

  return (
      $bundle,
      TMT::_interleave(@$tt_trees, @$st_trees),
      TMT::_interleave(@$ta_trees, @$sa_trees),
      TMT::_interleave(@$sm_trees),
      TMT::_interleave(@$sn_trees),
      TMT::_interleave(@$sp_trees)
  );
}


